QGIS Application - Bug report #2819
Copied record field mismatch from shapefile to postgis
2010-06-18 01:28 AM - bonzai -

Status: Closed

Priority: Low

Assignee: Jurgen Fischer

Category: Data Provider

Affected QGIS version: Regression?: No
Operating System: Gentoo Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupts data: Copied to github as #: 12879
Description

During feature copy (using Ctrl+C Ctrl+V) between shapefile and postgis layers field's values are someway shifted.

Original SHAPEFILE feature attributes

app_id: NULL

su_id: NULL

su: 36 <-------- RIGHT

phase: NULL

date: NULL

Copied [[PostGIS]] feature attributes

app_id: NULL

su_id: 36 <--------- WRONG

su: NULL

phase: NULL

date: NULL

Associated revisions

Revision 49dc9961 - 2010-06-26 10:17 PM - Jiirgen Fischer

fix #2819

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@13808 c¢8812cc2-4d05-0410-92ff-de0c093fc19¢c

Revision 34335d58 - 2010-06-26 10:17 PM - Jiirgen Fischer

fix #2819
git-svn-id: http://svn.osgeo.org/qgis/trunk@13808 ¢8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2010-06-18 01:44 AM - Jiirgen Fischer

The field values are assigned in order not by name. Does the attribute order in your postgis table match the order of fields in the shapefile's dbf?

#2 - 2010-06-18 02:29 AM - bonzai -

Replying to [comment:1 jef]:

The field values are assigned in order not by name.

Looking in layers' properties attribute tab I've found this:

SHAPEFILE

-lidjname

1|0 |app_id

21 |su_id

3[2 [su <--o

4|3 |phase

5|4 |date

POSTGIS

-lidjname

1|0 |app_id

2|2 |su_id

3|3 |su <-------

4|4 |phase

5|5 |date

Does the attribute order in your postgis table match the order of fields in the shapefile's dbf?

So it seems thats records have the same order but different ids.

A further information that could you help: the shapefile is the result of 'Export as shapefile' QGIS command.

#3 - 2010-06-18 02:49 AM - Juirgen Fischer

Might the geometry column in postgis not be the last column?
#4 - 2010-06-18 03:13 AM - bonzai -

Replying to [comment:3 jef]:

Might the geometry column in postgis not be the last column?

Actually it's not a table but a view with insert,update,delete rules:
CREATE OR REPLACE VIEW dataschemaname.w_core_geom_sus AS
SELECT g.app_id, g.geom, s.app_id AS su_id, s.short_def AS su, ph.short_def AS phase, s.date
FROM dataschemaname.core_geom_sus g
LEFT JOIN dataschemaname.core_std_sus s ON g.su_id = s.app_id
LEFT JOIN dataschemaname.core_voc_phases ph ON s.phase_id = ph.app_id;
As you can see the geometry column is the second one. Should it be the last one?
It's not a big issue but I've never heard about this...
#5 - 2010-06-18 03:44 AM - bonzai -
Replying to [comment:3 jef]:
Might the geometry column in postgis not be the last column?
Reoerdering view's fields putting geometry colums last works for me.

But in my opinion it's just a workaround and not a proper solution so | just changed the priority to minor.

Thanks for the quick answer

#6 - 2010-06-18 03:48 AM - Jiirgen Fischer

Replying to [comment:5 bonzai]:

Reoerdering view's fields putting geometry colums last works for me.

But in my opinion it's just a workaround and not a proper solution so | just changed the priority to minor.

Sure itis.

#7 - 2010-06-26 01:17 PM - Jiirgen Fischer
- Resolution set to fixed
- Status changed from Open to Closed

fixed in commit:34335d58 (SVN r13809).
